All patches and comments are welcome. Please squash your changes to logical
commits before using git-format-patch and git-send-email to
patches@git.madduck.net.
If you'd read over the Git project's submission guidelines and adhered to them,
I'd be especially grateful.
3 # This program is licensed under the GNU GPL version 2 or later.
4 # (c) Richard "RichiH" Hartmann <richih.mailinglist@gmail.com>, 2011-2012
5 # For details, see LICENSE. To submit patches, you have to agree to
6 # license your code under the GNU GPL version 2 or later.
8 # While the following is not legally binding, the author would like to
9 # explain the choice of GPLv2+ over GPLv3+.
10 # The author prefers GPLv3+ over GPLv2+ but feels it's better to maintain
11 # full compability with git. In case git ever changes its licensing terms,
12 # this software will most likely follow suit.
17 echo "$SELF: fatal: $1" >&2
21 # We need to run getops as soon as possible so we catch -d and other
22 # options that will modify our behaviour.
23 # Commands are handled at the end of this script.
24 while getopts "c:dv" flag; do
25 if [ "$1" = '-d' ] || [ "$1" = '--debug' ]; then
29 elif [ "$1" = '-v' ];then
31 elif [ "$1" = '-c' ];then
32 # Source $OPTARG if it can be read and has an absolute or relative
34 if [ -r "$OPTARG" ]; then
37 fatal "Can not read configuration file '$OPTARG'" 1
43 [ -n "$VCSH_DEBUG" ] && set -vx
44 [ -z "$XDG_CONFIG_HOME" ] && XDG_CONFIG_HOME="$HOME/.config"
45 [ -r "$XDG_CONFIG_HOME/vcsh/config" ] && . "$XDG_CONFIG_HOME/vcsh/config"
46 [ -n "$VCSH_DEBUG" ] && set -vx
47 [ -z "$VCSH_REPO_D" ] && VCSH_REPO_D="$XDG_CONFIG_HOME/vcsh/repo.d"
48 [ -z "$VCSH_HOOK_D" ] && VCSH_HOOK_D="$XDG_CONFIG_HOME/vcsh/hooks-enabled"
49 [ -z "$VCSH_BASE" ] && VCSH_BASE="$HOME"
50 [ -z "$VCSH_GITIGNORE" ] && VCSH_GITIGNORE='exact'
53 echo "usage: $SELF <options> <command>
56 -c <file> Source file prior to other configuration files
58 -d Enable verbose mode
62 [<repo>] Clone from an existing repository
63 delete Delete an existing repository
64 enter Enter repository; spawn new instance of \$SHELL
65 help Display this help text
66 init <repo> Initialize a new repository
67 list List all repositories
68 list-tracked List all files tracked by vcsh
70 <repo> List files tracked by a repository
72 <newname> Rename repository
74 <command> Use this repository
75 setup Set up repository with recommended settings
76 which <substring> Find substring in name of any tracked file
78 <repo> Write .gitignore.d/<repo> via git ls-files
80 <repo> <git command> Shortcut to run git commands directly
81 <repo> Shortcut to enter repository" >&2
85 [ -n "$VCSH_DEBUG" ] && echo "$SELF: debug: $@"
89 if [ -n "$VCSH_DEBUG" ] || [ -n "$VCSH_VERBOSE" ]; then echo "$SELF: verbose: $@"; fi
93 echo "$SELF: error: $1" >&2
97 echo "$SELF: info: $1"
102 git remote add origin "$GIT_REMOTE"
103 git config branch.master.remote origin
104 git config branch.master.merge refs/heads/master
105 if [ $(git ls-remote origin master 2> /dev/null | wc -l ) -lt 1 ]; then
106 info "remote is empty, not merging anything"
110 for object in $(git ls-tree -r origin/master | awk '{print $4}'); do
112 error "'$object' exists." &&
115 [ "$VCSH_CONFLICT" = '1' ] &&
116 fatal "will stop after fetching and not try to merge!
117 Once this situation has been resolved, run 'vcsh run $VCSH_REPO_NAME git pull' to finish cloning.\n" 17
118 git merge origin/master
122 cd "$VCSH_BASE" || fatal "could not enter '$VCSH_BASE'" 11
124 info "This operation WILL DETROY DATA!"
125 files=$(git ls-files)
126 echo "These files will be deleted:
130 AGAIN, THIS WILL DELETE YOUR DATA!
131 To continue, type 'Yes, do as I say'"
133 [ "x$answer" = 'xYes, do as I say' ] || exit 16
134 for file in $files; do
135 rm -f $file || info "could not delete '$file', continuing with deletion"
137 rm -r "$GIT_DIR" || error "could not delete '$GIT_DIR'"
148 [ -d "$GIT_DIR" ] || fatal "no repository found for '$VCSH_REPO_NAME'" 12
152 for hook in $VCSH_HOOK_D/$1* $VCSH_HOOK_D/$VCSH_REPO_NAME.$1*; do
153 [ -x "$hook" ] || continue
154 info "executing '$hook'"
160 [ ! -e "$GIT_DIR" ] || fatal "'$GIT_DIR' exists" 10
161 export GIT_WORK_TREE="$VCSH_BASE"
162 mkdir -p "$GIT_WORK_TREE" || fatal "could not create '$GIT_WORK_TREE'" 50
163 cd "$GIT_WORK_TREE" || fatal "could not enter '$GIT_WORK_TREE'" 11
169 for repo in "$VCSH_REPO_D"/*.git; do
170 [ -d "$repo" ] && [ -r "$repo" ] && echo $(basename "$repo" .git)
175 export GIT_DIR="$VCSH_REPO_D/$VCSH_REPO_NAME.git"
180 for VCSH_REPO_NAME in $(list); do
187 git ls-files | sort -u
192 [ -d "$GIT_DIR_NEW" ] && fatal "'$GIT_DIR_NEW' exists" 54
193 mv -f "$GIT_DIR" "$GIT_DIR_NEW" || fatal "Could not mv '$GIT_DIR' '$GIT_DIR_NEW'" 52
200 $VCSH_EXTERNAL_COMMAND
207 git config core.worktree "$GIT_WORK_TREE"
208 git config core.excludesfile ".gitignore.d/$VCSH_REPO_NAME"
209 git config vcsh.vcsh 'true'
210 [ -e "$VCSH_BASE/.gitignore.d/$VCSH_REPO_NAME" ] && git add -f "$VCSH_BASE/.gitignore.d/$VCSH_REPO_NAME"
216 export GIT_WORK_TREE="$(git config --get core.worktree)"
217 export VCSH_DIRECTORY="$VCSH_REPO_NAME"
221 for VCSH_REPO_NAME in $(list); do
222 for VCSH_FILE in $(get_files); do
223 echo $VCSH_FILE | grep -q "$VCSH_COMMAND_PARAMETER" && echo "$VCSH_REPO_NAME: $VCSH_FILE"
230 cd "$VCSH_BASE" || fatal "could not enter '$VCSH_BASE'" 11
231 gitignores=$(for file in $(git ls-files); do
233 echo $file; new="${file%/*}"
234 [ "$file" = "$new" ] && break
238 tempfile=$(mktemp) || fatal "could not create tempfile" 51
239 echo '*' > "$tempfile" || fatal "could not write to '$tempfile'" 57
240 for gitignore in $gitignores; do
241 echo "$gitignore" | sed 's/^/!/' >> "$tempfile" || fatal "could not write to '$tempfile'" 57
242 if [ x$VCSH_GITIGNORE = x'recursive' ] && [ -d "$gitignore" ]; then
243 { echo "$gitignore/*" | sed 's/^/!/' >> "$tempfile" || fatal "could not write to '$tempfile'" 57; }
246 if diff -N "$tempfile" "$VCSH_BASE/.gitignore.d/$VCSH_REPO_NAME" > /dev/null; then
247 rm -f "$tempfile" || error "could not delete '$tempfile'"
250 if [ -e "$VCSH_BASE/.gitignore.d/$VCSH_REPO_NAME" ]; then
251 info "'$VCSH_BASE/.gitignore.d/$VCSH_REPO_NAME' differs from new data, moving it to '$VCSH_BASE/.gitignore.d/$VCSH_REPO_NAME.bak'"
252 mv -f "$VCSH_BASE/.gitignore.d/$VCSH_REPO_NAME" "$VCSH_BASE/.gitignore.d/$VCSH_REPO_NAME.bak" ||
253 fatal "could not move '$VCSH_BASE/.gitignore.d/$VCSH_REPO_NAME' to '$VCSH_BASE/.gitignore.d/$VCSH_REPO_NAME.bak'" 53
255 mv -f "$tempfile" "$VCSH_BASE/.gitignore.d/$VCSH_REPO_NAME" ||
256 fatal "could not move '$tempfile' to '$VCSH_BASE/.gitignore.d/$VCSH_REPO_NAME'" 53
259 if [ ! "x$VCSH_GITIGNORE" = 'xexact' ] && [ ! "x$VCSH_GITIGNORE" = 'xrecursive' ]; then
260 fatal "'\$VCSH_GITIGNORE' must be either 'exact' or 'recursive'" 1
263 if [ "$1" = 'clone' ]; then
264 [ -z "$2" ] && fatal "$1: please specify a remote" 1
265 export VCSH_COMMAND="$1"
267 [ -n "$3" ] && VCSH_REPO_NAME="$3" || VCSH_REPO_NAME=$(basename "$GIT_REMOTE" .git)
268 export VCSH_REPO_NAME
269 export GIT_DIR="$VCSH_REPO_D/$VCSH_REPO_NAME.git"
270 elif [ "$1" = 'which' ]; then
271 [ -z "$2" ] && fatal "$1: please specify a filename" 1
272 [ -n "$3" ] && fatal "$1: too many parameters" 1
273 export VCSH_COMMAND="$1"
274 export VCSH_COMMAND_PARAMETER="$2"
275 elif [ "$1" = 'delete' ] ||
276 [ "$1" = 'enter' ] ||
278 [ "$1" = 'list-tracked-by' ] ||
279 [ "$1" = 'rename' ] ||
281 [ "$1" = 'setup' ] ||
282 [ "$1" = 'write-gitignore' ]; then
283 [ -z $2 ] && fatal "$1: please specify repository to work on" 1
284 [ "$1" = 'rename' -a -z "$3" ] && fatal "$1: please specify a target name" 1
285 [ "$1" = 'run' -a -z "$3" ] && fatal "$1: please specify a command" 1
286 export VCSH_COMMAND="$1"
287 export VCSH_REPO_NAME="$2"
288 export GIT_DIR="$VCSH_REPO_D/$VCSH_REPO_NAME.git"
289 [ "$VCSH_COMMAND" = 'rename' ] && export GIT_DIR_NEW="$VCSH_REPO_D/$3.git"
290 [ "$VCSH_COMMAND" = 'run' ] && shift 2 && export VCSH_EXTERNAL_COMMAND="$*"
291 [ "$VCSH_COMMAND" = 'write-gitignore' ]
292 elif [ "$1" = 'list' ] ||
293 [ "$1" = 'list-tracked' ]; then
294 export VCSH_COMMAND="$1"
295 elif [ -n "$2" ]; then
296 export VCSH_COMMAND='run'
297 export VCSH_REPO_NAME="$1"
298 export GIT_DIR="$VCSH_REPO_D/$VCSH_REPO_NAME.git"
299 [ -d $GIT_DIR ] || { help; exit 1; }
301 export VCSH_EXTERNAL_COMMAND="git $*"
302 elif [ -n "$1" ]; then
303 export VCSH_COMMAND='enter'
304 export VCSH_REPO_NAME="$1"
305 export GIT_DIR="$VCSH_REPO_D/$VCSH_REPO_NAME.git"
306 [ -d $GIT_DIR ] || { help; exit 1; }
308 # $1 is empty, or 'help'
312 # Did we receive a directory instead of a name?
313 # Mangle the input to fit normal operation.
314 if echo $VCSH_REPO_NAME | grep -q '/'; then
315 export GIT_DIR=$VCSH_REPO_NAME
316 export VCSH_REPO_NAME=$(basename "$VCSH_REPO_NAME" .git)
320 for check_directory in "$VCSH_REPO_D" "$VCSH_BASE/.gitignore.d"
322 if [ ! -d "$check_directory" ]; then
323 if [ -e "$check_directory" ]; then
324 fatal "'$check_directory' exists but is not a directory" 13
326 info "attempting to create '$check_directory'"
327 mkdir -p "$check_directory" || fatal "could not create '$check_directory'" 50
332 verbose "$VCSH_COMMAND begin"
333 export VCSH_COMMAND=$(echo $VCSH_COMMAND | sed 's/-/_/g')
337 verbose "$VCSH_COMMAND end, exiting"